#!/bin/sh

### Set up paths

# location of your java executable (version 1.2 or higher)
#JAVA=/usr/local/jdk1.3/bin/java
JAVA=java

# location where you installed the Hydra files
HYDRA_DIR=${HOME}/Hydra

# java search path
CLASSPATH=$CLASSPATH:$HYDRA_DIR:$HYDRA_DIR/Jama-1.0.1.jar:$HYDRA_DIR/DataReader.jar:$HYDRA_DIR/colt.jar
export CLASSPATH

### copy the required input file to the current directory
cp $HYDRA_DIR/org/omegahat/Simulation/MCMC/Examples/BarrettsLOH.dat .
cp $HYDRA_DIR/org/omegahat/Simulation/MCMC/Examples/NKC.states.in .
cp $HYDRA_DIR/org/omegahat/Simulation/MCMC/Examples/NKC.variance.in .


### Run the example programsa
echo
echo " ******************************************** "
echo " ** Executing Binomial_BetaBinomialExample ** "
echo " ******************************************** "
echo
$JAVA org.omegahat.Simulation.MCMC.Examples.Binomial_BetaBinomialExample

echo
echo " ********************************************* "
echo " ** Executing Binomial_BetaBinomial_Example ** "
echo " ********************************************* "
echo
$JAVA org.omegahat.Simulation.MCMC.Examples.Binomial_BetaBinomial_Example

echo
echo " ************************************************ "
echo " ** Executing Binomial_BetaBinomial_Example_II ** "
echo " ************************************************ "
echo
$JAVA org.omegahat.Simulation.MCMC.Examples.Binomial_BetaBinomial_Example_II

echo
echo " ************************************************* "
echo " ** Executing Binomial_BetaBinomial_Example_III ** "
echo " ************************************************* "
echo
$JAVA org.omegahat.Simulation.MCMC.Examples.Binomial_BetaBinomial_Example_III

echo
echo " ************************************************* "
echo " ** Executing Binomial_BetaBinomial_Example_NKC ** "
echo " ************************************************* "
echo
$JAVA org.omegahat.Simulation.MCMC.Examples.Binomial_BetaBinomial_Example_NKC

echo
echo " ******************************************************** "
echo " ** Executing Binomial_BetaBinomial_Example_NKC_Bimode ** "
echo " ******************************************************** "
echo
$JAVA org.omegahat.Simulation.MCMC.Examples.Binomial_BetaBinomial_Example_NKC_Bimode 20000

echo
echo " ******************************************************** "
echo " ** Executing Binomial_BetaBinomial_Example_KDS_Bimode ** "
echo " ******************************************************** "
echo
$JAVA org.omegahat.Simulation.MCMC.Examples.Binomial_BetaBinomial_Example_KDS_Bimode 20000


