// line 170 "ExpressionTarget.jweb"
/*;
Copyright (c) 1998 The Omega Project for Statistical Computing.  
All rights reserved.

*/


// line 151 "ExpressionTarget.jweb"
   package org.omegahat.Simulation.MCMC.Expressions;


// line 157 "ExpressionTarget.jweb"
    import org.omegahat.Simulation.MCMC.*;
    import org.omegahat.Simulation.MCMC.Listeners.*;
    import org.omegahat.Simulation.MCMC.Proposals.*;
    import org.omegahat.Simulation.MCMC.Targets.*;

import org.omegahat.Models.Formulae.Expressions.*;
import org.omegahat.Environment.Interpreter.*;
import org.omegahat.Environment.Parser.Parse.*;
import org.omegahat.Environment.Databases.*;
import java.util.Enumeration;
import org.omegahat.Probability.Distributions.*;

// line 7 "ExpressionTarget.jweb"
public class ExpressionTarget extends ExpressionModel implements UnnormalizedDensity
{


// line 21 "ExpressionTarget.jweb"
protected List expressions;



// line 27 "ExpressionTarget.jweb"
public List expressions() {
  return( expressions );
}

public List expressions(List l) {
  expressions = l;
  return(expressions());
}


// line 126 "ExpressionTarget.jweb"
public ExpressionTarget( MultiLineModelFormula model, 
			Database environment ) throws Exception
{
  super( model,  environment);
  expressions = createExpressions();
}

public ExpressionTarget( String   model,
			Database environment        ) throws Exception
{
  super( model,  environment);
  expressions = createExpressions();
}

public ExpressionTarget( String[] model,
			Database environment ) throws Exception
{
  super( model,  environment);
  expressions = createExpressions();
}


// line 39 "ExpressionTarget.jweb"
public List createExpressions() 
{

 List expressions = new List(model.size());

  /* Create expressions whose values will be computed and 
    Multiplied in the eval()/nextStep()..... method at each iteration. */
 for(int i = 0; i < model.size() ; i++) {

   /*!!!!!!! Assumes name ~ Fn(arg1, arg2, ..) !!!!!!!!*/

   ModelFormula exp = (ModelFormula) model.elementAt(i);
   List l = (List) exp.structural();
   FunctionTransformationExpression f = (FunctionTransformationExpression) l.elementAt(0);
   Name n = (FormulaName) f.qualifier();

   List inArgs = f.args();
   List args = new List(inArgs.size() + 1);
    args.addElement(exp.response());
    for(int j = 0; j <  inArgs.size() ; j++)
      args.addElement(inArgs.elementAt(j));

   expressions.addElement(new CachingMethodCall(n, "logUnnormalizedPDF", args));
 }

return(expressions);
}


// line 73 "ExpressionTarget.jweb"
public double logUnnormalizedPDF( Object state )
{

  // create a new search path containing the state 
  SearchPath s = new SearchPath();
  // scratch in positions 0
  s.attach( (MCMCStateDatabase) state, 1 );
  s.attach( environment, 2 );
  searchPath(s);

  // evaluate the list of expressions using this state
  List el;

  try{ el= (List) expressions().eval(this); }
  catch ( Throwable ex )
  {
    ex.printStackTrace();
    throw new RuntimeException("Failed to evaluate: " + expressions() );
  }
	
  double total = 0.0;

  // now compute the product 
  for(Enumeration e = el.elements(); e.hasMoreElements() ;)
   total += ((Double) e.nextElement()).doubleValue();

 return(total);
}

public double unnormalizedPDF( Object state )
{
  return Math.exp(logUnnormalizedPDF( state ) ) ;
}

public double unnormalizedDensity( Object state )
{
  return unnormalizedPDF( state );
}

public double logUnnormalezedDensity( Object state )
{
  return logUnnormalizedPDF( state );
}



// line 16 "ExpressionTarget.jweb"
}
