/* Generated By:JavaCC: Do not edit this line. DataFileSpec.java */
//Fetch utility stuff.
package sir.estimate;

import sir.util.*;
import java.util.Vector;
import java.util.Stack;

/** Used to have plenty of classes here, but for now DataileSpec is all we need
 *  It is a JavaCC encoding of the grammar specifying recovery and infection times
 *  for each individual individual with such recordings. This is a new format
 *  compared to earlier, because we now give event times belonging to each individual
 *  instead of just event times. Furthermore, both inf, rec and diag events are specified.
 *
 *  @author Michael Hhle &gt;hoehle@dina.kvl.dk&lt;
 *  @version 23 January 2003
 */

public class DataFileSpec implements DataFileSpecConstants {
    //Data object
    static Data data = new Data();
    //Vector with units, until we know size and can convert to l1xl2.
    static Vector units = new Vector();
    //A stack, where we can throw things we pop off later
   Stack stack = new Stack();

   //Parameter indices
   int beta_   = 1;
   int betaN_  = 2;
   int gammaE_ = 3;
   int deltaE_ = 4;
   int gammaI_ = 5;
   int deltaI_ = 6;
   int gammaD_ = 7;
   int deltaD_ = 8;

    public static void main(String args[]) throws ParseException {
        try {
            DataFileSpec parser = new DataFileSpec(new java.io.FileInputStream("foo.txt"));
            parser.DataFile();
        } catch (java.io.FileNotFoundException e) {
            System.out.println(e);
        }
    }
    /** Deliver Data object with data read from file */
    public Data getData() {
      return(data);
    }

  final public void DataFile() throws ParseException {
    UnitList();
               /** Convert to an array and create data.units structure*/ data.setupUnitArrays(units);
    Beta();
    BetaN();
    Incu();
    Inf();
    Diag();
    CeaseTime();
    RecTimeList();
    jj_consume_token(0);
          /* Post-processing stuff */ data.postProcess();
  }

  final public void ParamStartValue(int paramNo) throws ParseException {
    jj_consume_token(13);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONSTANT:
      jj_consume_token(CONSTANT);
                       data.startVal[paramNo] = Double.parseDouble(token.image);
      break;
    case 14:
      jj_consume_token(14);
                       data.startVal[paramNo] = Double.NaN;
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(15);
  }

  final public void Beta() throws ParseException {
    jj_consume_token(16);
    jj_consume_token(CONSTANT);
                 data.nu[beta_]     = Double.parseDouble(token.image);
    jj_consume_token(CONSTANT);
                 data.lambda[beta_] = Double.parseDouble(token.image);
    ParamStartValue(beta_);

    jj_consume_token(EOL);
  }

  final public void BetaN() throws ParseException {
    jj_consume_token(17);
    jj_consume_token(CONSTANT);
                 data.nu[betaN_]     = Double.parseDouble(token.image);
    jj_consume_token(CONSTANT);
                 data.lambda[betaN_] = Double.parseDouble(token.image);
    ParamStartValue(betaN_);

    jj_consume_token(EOL);
  }

  final public void Incu() throws ParseException {
    jj_consume_token(18);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONSTANT:
      jj_consume_token(CONSTANT);
                         data.nu[gammaE_]     = Double.parseDouble(token.image);
      jj_consume_token(CONSTANT);
                         data.lambda[gammaE_] = Double.parseDouble(token.image);
      ParamStartValue(gammaE_);

      jj_consume_token(CONSTANT);
                         data.nu[deltaE_]     = Double.parseDouble(token.image);
      jj_consume_token(CONSTANT);
                         data.lambda[deltaE_] = Double.parseDouble(token.image);
      ParamStartValue(deltaE_);
      break;
    case 19:
      jj_consume_token(19);
      jj_consume_token(CONSTANT);
                         data.incu = Double.parseDouble(token.image);
      break;
    case 20:
      jj_consume_token(20);
                      data.incu = Double.NEGATIVE_INFINITY; /** code for asis */
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(EOL);
  }

  final public void Inf() throws ParseException {
    jj_consume_token(21);
    jj_consume_token(CONSTANT);
                 data.nu[gammaI_]     = Double.parseDouble(token.image);
    jj_consume_token(CONSTANT);
                 data.lambda[gammaI_] = Double.parseDouble(token.image);
    ParamStartValue(gammaI_);

    jj_consume_token(CONSTANT);
                 data.nu[deltaI_]     = Double.parseDouble(token.image);
    jj_consume_token(CONSTANT);
                 data.lambda[deltaI_] = Double.parseDouble(token.image);
    ParamStartValue(deltaI_);

    jj_consume_token(EOL);
  }

  final public void Diag() throws ParseException {
    jj_consume_token(22);
    jj_consume_token(CONSTANT);
                 data.nu[gammaD_]     = Double.parseDouble(token.image);
    jj_consume_token(CONSTANT);
                 data.lambda[gammaD_] = Double.parseDouble(token.image);
    ParamStartValue(gammaD_);

    jj_consume_token(CONSTANT);
                 data.nu[deltaD_]     = Double.parseDouble(token.image);
    jj_consume_token(CONSTANT);
                 data.lambda[deltaD_] = Double.parseDouble(token.image);
    ParamStartValue(deltaD_);

    jj_consume_token(EOL);
  }

/** In case there is any information about it being a transmission experiment */
  final public void CeaseTime() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 23:
      jj_consume_token(23);

      jj_consume_token(CONSTANT);
                   data.Ttime  = Double.parseDouble(token.image);
      jj_consume_token(EOL);
      break;
    default:
      jj_la1[2] = jj_gen;

    }
  }

  final public void UnitList() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 25:
      Unit();
      UnitList();
      break;
    default:
      jj_la1[3] = jj_gen;

    }
  }

  final public void Vaccinated() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 24:
      jj_consume_token(24);
                 stack.push(new Boolean(true));
      break;
    default:
      jj_la1[4] = jj_gen;
                 stack.push(new Boolean(false));
    }
  }

  final public void Unit() throws ParseException {
 int thisIndex; int posx,posy,N,a; boolean vacc;
    jj_consume_token(25);
    jj_consume_token(CONSTANT);
                    posx = Integer.parseInt(token.image);
    jj_consume_token(CONSTANT);
                    posy = Integer.parseInt(token.image);
    jj_consume_token(CONSTANT);
                    N    = Integer.parseInt(token.image);
    jj_consume_token(CONSTANT);
                    a    = Integer.parseInt(token.image);
    Vaccinated();
                    vacc =((Boolean)stack.pop()).booleanValue();
    jj_consume_token(EOL);
        //Add the unit - this solution is not very pretty, coz we use a global variable
        //to store the info on the prior lists before assigning them. A nicer solution,
        //where local copies are stored should be desired!
        units.add(data.noOfUnits++,new Unit(posx,posy,N,a,vacc));
  }

/** Start valu of a time */
  final public void StartValue() throws ParseException {
  /** Push a NaN on the stack to indicate it's parametric */
  stack.push(new Double(Double.NaN));
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONSTANT:
      jj_consume_token(CONSTANT);
                stack.push(new Double(Double.parseDouble(token.image)));
      break;
    case NA:
      jj_consume_token(NA);
                stack.push(new Double(Double.NaN));
      break;
    default:
      jj_la1[5] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/** Event time - either a double or NA with start value
* We throw on stack in top: startValue, top-1: t
*/
  final public void EventTime() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONSTANT:
      jj_consume_token(CONSTANT);
                stack.push(new Double(Double.parseDouble(token.image))); stack.push(new Double(Double.NaN));
      break;
    case 13:
      jj_consume_token(13);
      StartValue();
      jj_consume_token(15);

      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/** Diagnosed events can be censored */
  final public void DiagEventTime() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONSTANT:
    case 13:
      EventTime();
      break;
    case CENSORED:
      jj_consume_token(CENSORED);
                  stack.push(new String("censored")); stack.push(new Double(Double.NaN));
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/** Each individual having events is listed, one per line with format
*   posx posy eventTime eventTime
*/
  final public void RecTimeList() throws ParseException {
    /*Variables for saving */
    int posx=0,posy=0,thisIndex=0;
    double infTime[] = new double[2];
    double recTime[] = new double[2];
    double diagTime[]= new double[2];
    double expTime[] = new double[2];
    boolean diagCensored = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONSTANT:
      jj_consume_token(CONSTANT);
                 posx     = Integer.parseInt(token.image);
      jj_consume_token(CONSTANT);
                 posy     = Integer.parseInt(token.image);
      EventTime();
                  expTime[0] = ((Double)stack.pop()).doubleValue(); expTime[1] = ((Double)stack.pop()).doubleValue();
      EventTime();
                  infTime[0] = ((Double)stack.pop()).doubleValue(); infTime[1] = ((Double)stack.pop()).doubleValue();
      EventTime();
                  recTime[0] = ((Double)stack.pop()).doubleValue(); recTime[1] = ((Double)stack.pop()).doubleValue();
      DiagEventTime();
                      // The stack consists of top (start value) and top-1 the value
                      diagTime[0] = ((Double)stack.pop()).doubleValue();
                      Object o = stack.pop();

                      //If it is a censored event then censoring time is at recovery
                      if (o.getClass().getName() == "java.lang.String") {
                          diagTime[1] = recTime[1];
                          diagCensored = true;
                      } else {
                          diagTime[1] = ((Double)o).doubleValue();
                      }
      jj_consume_token(EOL);
            /** Would like to get rid of this EOL*/ thisIndex = data.noOfIndividuals++;
      RecTimeList();
                     //Safeguard that the specified unit does exists in the data.units array
                     try {
                        //Create the exposure event
                        data.E[thisIndex] = new Event(data.units[posx][posy],expTime,'E');
                        //Create the infectious event.
                        data.I[thisIndex] = new Event(data.units[posx][posy],infTime,'I');
                        //Create the recovery event.
                        data.R[thisIndex] = new Event(data.units[posx][posy],recTime,'R');
                        //Create the diagnostic test event
                        data.D[thisIndex] = new Event(data.units[posx][posy],diagTime,'D',diagCensored);

                        //Make event links
                        data.E[thisIndex].nextIndividualEvent = data.I[thisIndex];
                        data.I[thisIndex].nextIndividualEvent = data.R[thisIndex];

                      } catch (ArrayIndexOutOfBoundsException e) {
                        {if (true) throw new ParseException("Error in line " + token.beginLine  + ": The unit (" + posx + "," + posy + ") does not exist.");}
                      }
      break;
    default:
      jj_la1[8] = jj_gen;
          //Bottom of list - ready to new the two necessary data structures
            data.E = new Event[data.noOfIndividuals];
            data.I = new Event[data.noOfIndividuals];
            data.R = new Event[data.noOfIndividuals];
            data.D = new Event[data.noOfIndividuals];
    }
  }

  public DataFileSpecTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[9];
  final private int[] jj_la1_0 = {0x4080,0x180080,0x800000,0x2000000,0x1000000,0xa0,0x2080,0x20c0,0x80,};

  public DataFileSpec(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new DataFileSpecTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  public DataFileSpec(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new DataFileSpecTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  public DataFileSpec(DataFileSpecTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  public void ReInit(DataFileSpecTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[26];
    for (int i = 0; i < 26; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 9; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 26; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
