

// line 110 "PlottingListener.jweb"
  package org.omegahat.Simulation.MCMC.Listeners;


// line 116 "PlottingListener.jweb"
    import org.omegahat.Simulation.MCMC.*;

import java.util.Vector;
import org.omegahat.Graphics.Plots.*;
import org.omegahat.Graphics.Devices.*;


// line 10 "PlottingListener.jweb"
/**
 * Displays contents and counter of <code>RecordingIndexEvent<code>s when one is recieved.
 */
public class PlottingListener extends ArrayListener
{
    
// line 25 "PlottingListener.jweb"
SwingDeviceWindow[] plotWindows;
Scatterplot[] plots;

int refreshInterval = 100;

// line 16 "PlottingListener.jweb"
    
// line 34 "PlottingListener.jweb"
public int refreshInterval() { return refreshInterval; }
public int refreshInterval( int delay ) { return refreshInterval = delay; }

public SwingDeviceWindow[] plotWindows() { return  plotWindows; }
public Scatterplot[] plots() { return plots; };



// line 17 "PlottingListener.jweb"
    
// line 47 "PlottingListener.jweb"
public PlottingListener( String[] varNames)
{
  this(varNames, 1000);
}

public PlottingListener ( String[] varNames, int size )
{
  super(varNames, size);

  plotWindows = new SwingDeviceWindow[this.varNames.length];
  plots = new Scatterplot[this.varNames.length];

  for(int i=0; i < this.varNames.length; i++ )
    {
      plotWindows[i] = new SwingDeviceWindow( this.varNames[i] + " vs time",true);
    }

}

// line 18 "PlottingListener.jweb"
    
// line 70 "PlottingListener.jweb"
public void notify( MCMCEvent e )
{
  super.notify( e );

  //  int index = (( index + 40 ) % mu().length );
  //  mu()[index] = Double.NaN;
  //  rho()[index] = Double.NaN;

  if ( ( index % refreshInterval() ) == 0 ) 
  {
    for(int i=0; i<varNames.length; i++)
      {
	if(plots[i]==null)
	  {
	    plots[i]  = new Scatterplot( time , 
					 data[i], 
					 Scatterplot.LINES ); 
	    // | Scatterplot.WITH_BREAKS );
	    //	    plots[i].setXLabel( varNames[i] );
	    plotWindows[i].plot(plots[i]);
	  }
	//	plotWindows[i].getComponents()[0].hide();
		plotWindows[i].getComponents()[0].show(false);
		plotWindows[i].getComponents()[0].show(true);
		//		plotWindows[i].getComponents()[0].repaint();
      }
  }
}

// line 19 "PlottingListener.jweb"
    
// line 103 "PlottingListener.jweb"
    /* none */


// line 20 "PlottingListener.jweb"
}
