
// line 16 "CollingsCorbaPRNGFactory.jweb"
package org.omegahat.Simulation.RandomGenerators;

public class CollingsCorbaPRNGFactory 
               extends CorbaPRNGFactory
{
 
// line 30 "CollingsCorbaPRNGFactory.jweb"
      PRNGFactory factory;

// line 23 "CollingsCorbaPRNGFactory.jweb"
 
// line 33 "CollingsCorbaPRNGFactory.jweb"
public CollingsCorbaPRNGFactory() 
{
}

// line 24 "CollingsCorbaPRNGFactory.jweb"
 
// line 40 "CollingsCorbaPRNGFactory.jweb"
public CorbaPRNGUtil.PRNG instantiate(CorbaPRNGUtil.PRNGState corbaState)
{
    PRNG prng = localInstantiate(corbaState);
    return new CorbaPRNG( (PRNG) prng );
}
      
   

public PRNG localInstantiate(CorbaPRNGUtil.PRNGState corbaState)
{
  PRNG prng;
  String prngName;

  /* Get the PRNG's class name */
  prngName = corbaState.getPRNGName();

  System.out.println("Trying to Instantiate a PRNG of class " + prngName + " " + 
	(corbaState instanceof CorbaPRNGUtil.CollingsPRNGState ) ) ;

  /* Test to see if we know how to instantiate it, and do the right thing */  
  if (prngName.equals("org.omegahat.Simulation.RandomGenerators.CollingsPRNG"))
    {	
      try
	{
	  
	  System.err.println("PRNGStateClass :" + corbaState.getClass() );
	  
	  CorbaPRNGUtil.CollingsPRNGState cState = CorbaPRNGUtil.CollingsPRNGStateHelper.narrow(corbaState);
	  if(cState==null)
	    throw new RuntimeException("Failed attempt to narrow to CollingsPRNGState.");
	  
	  prng = new CollingsPRNG(cState.getNumGen(),
				  cState.getMixerMult(),
				  cState.getMixerSeed(),
				  cState.getComponentMult(),
				  cState.getComponentSeed());
	  
	  return prng;
	}
      
      catch(Exception ex) 
	{
	  ex.printStackTrace();
	  throw new RuntimeException("Failed attempt to instantiate");
	}
    }
    
  /* We don't know how to handle this class. See if our parent does. 
   * If none of our parents do, an exception will be thrown to alert the
   *   caller. 
   */
  
  return super.localInstantiate(corbaState);
      
}


// line 25 "CollingsCorbaPRNGFactory.jweb"
}


